#include "Mass.h"

CMass::CMass()
{
	Location.x=0;
	Location.y=0;
	Location.z=0;

	fLocation.x=0;
	fLocation.y=0;
	fLocation.z=0;

	PreviousLoc.x=0;
	PreviousLoc.y=0;
	PreviousLoc.z=0;


	Force.x=0;
	Force.y=0;
	Force.z=0;

	ForceIntegrals.x=0;
	ForceIntegrals.y=0;
	ForceIntegrals.z=0;

	ErrorIntegrals.x=0;
	ErrorIntegrals.y=0;
	ErrorIntegrals.z=0;

	Mass=0;
	Air=0;

}

CMass::~CMass()
{

}

void CMass::Initialize (short int x,short int y,short int z,short int m,short int A,short int Fx,short int Fy,short int Fz)
{
	Location.x=x;
	Location.y=y;
	Location.z=z;

	fLocation.x=x;
	fLocation.y=y;
	fLocation.z=z;
	
	PreviousLoc.x=x;
	PreviousLoc.y=y;
	PreviousLoc.z=z;

	Force.x=Fx;
	Force.y=Fy;
	Force.z=Fz;

	ForceIntegrals.x=0;
	ForceIntegrals.y=0;
	ForceIntegrals.z=0;

	ErrorIntegrals.x=0;
	ErrorIntegrals.y=0;
	ErrorIntegrals.z=0;

	Mass=m;
	Air=A;

}

void CMass::CalculateForces(float kp,float kd,float ki,float kp2,float kd2,float ki2,float kp3,float kd3,float ki3,short int x,short int y,short int z)
{
	ErrorIntegrals.x+=0.5*(2*x-fLocation.x-PreviousLoc.x);
	ErrorIntegrals.y+=0.5*(2*y-fLocation.y-PreviousLoc.y);
	ErrorIntegrals.z+=0.5*(2*z-fLocation.z-PreviousLoc.z);

	Force.x=kp*(x-fLocation.x)+kd*(-fLocation.x+PreviousLoc.x)+ki*ErrorIntegrals.x;
	Force.y=kp2*(y-fLocation.y)+kd2*(-fLocation.y+PreviousLoc.y)+ki2*ErrorIntegrals.y;
	Force.z=kp3*(z-fLocation.z)+kd3*(-fLocation.z+PreviousLoc.z)+ki3*ErrorIntegrals.z;

}
void CMass::CalculateNextLocation()
{
	
	PreviousLoc=fLocation;

	ForceIntegrals.x+=Force.x-Air;
	ForceIntegrals.y+=Force.y-Air;
	ForceIntegrals.z+=Force.z-Air;

	fLocation.x+=0.5*ForceIntegrals.x/(float)Mass;
	fLocation.y+=0.5*ForceIntegrals.y/(float)Mass;
	fLocation.z+=0.5*ForceIntegrals.z/(float)Mass;

	ForceIntegrals.x=Force.x-Air;
	ForceIntegrals.y=Force.y-Air;
	ForceIntegrals.z=Force.z-Air;

	Location.x=(short int) fLocation.x;
	Location.y=(short int) fLocation.y;
	Location.z=(short int) fLocation.z;

}

void CMass::UpdateForces(short int Fx,short int Fy,short int Fz)
{
	Force.x=Fx;
	Force.y=Fy;
	Force.z=Fz;
}

void CMass::GetForcesStr(char *str)
{
	sprintf(str,": %d,%d,%d",Force.x,Force.y,Force.z);
}

void CMass::GetLocationStr(char *str)
{
	sprintf(str," : %d,%d,%d",Location.x,Location.y,Location.z);

}